'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = NuclearModule;

var _nuclearJs = require('nuclear-js');

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _lodash = require('lodash.omit');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.isarray');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.foreach');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.reduce');

var _lodash8 = _interopRequireDefault(_lodash7);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function NuclearModule(options) {
  var stores = options.stores || {};
  var actions = options.actions || {};
  var getters = options.getters || {};

  return function (reactor, StoreFactory) {
    StoreFactory = StoreFactory || _nuclearJs.Store;

    var _stores = stores.reduce(function (acc, store) {
      var storeName = store.name;
      var storeDefinition = (0, _lodash2.default)(store, 'name');

      if (reactor.evaluate([storeName])) {
        // TODO: Show a warning unless `debug/dev` mode.
        return;
      }

      var handlers = storeDefinition.handlers || {};

      storeDefinition = _extends({}, (0, _lodash2.default)(storeDefinition, 'handlers'), {
        initialize: function initialize() {
          var _this = this;

          (0, _lodash6.default)(handlers, function (_ref) {
            var type = _ref.type;
            var handler = _ref.handler;

            _this.on(type, handler);
          });
        }
      });

      return _extends({}, acc, _defineProperty({}, storeName, StoreFactory(storeDefinition)));
    }, {});

    reactor.registerStores(_stores);

    return {
      getters: getters,
      actions: createActions(reactor, actions)
    };
  };
}

function createActions(reactor, actions) {
  return (0, _lodash8.default)(actions, function (result, action, actionName) {
    return _extends({}, result, _defineProperty({}, actionName, action.bind(null, reactor)));
  }, {});
}